package com.s3ai.corporate_app2.controllers.rest

import com.s3ai.corporate_app2.Cinema
import com.s3ai.corporate_app2.CinemaService
import com.s3ai.corporate_app2.controllers.deleteInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*
import java.util.*
import javax.servlet.http.HttpServletResponse
import kotlin.random.Random

@RestController
@RequestMapping("/api/cinemas")
class CinemaApiController {
    @Autowired
    lateinit var cinemaService: CinemaService

    @GetMapping("/fill")
    fun fillCinemas(): String? {
        val locations: List<String> = listOf("Samara", "Izhevsk", "NeoTokyo", "Bangladesh", "Moscow", "Grozny");
        val names: List<String> = listOf("Nol", "Tcelkoviy", "Polushka", "Chekushka", "Osmushka", "Pudovichok", "Mediachok", "Silverchok", "Goldenchok", "Deviatichek", "Desatichek");
        val generatedNames: MutableList<String> = mutableListOf()
        for (i in 0..300) {
            val cinema = Cinema();
            cinema.id = UUID.randomUUID();
            cinema.name = names.random();
            generatedNames.add(cinema.name.toString())
            cinema.seatsCount = Random.nextInt(50, 300);
            cinema.location = locations.random();
            cinemaService.save(cinema);
        }
        return generatedNames.toString()
    }

    @DeleteMapping("/delete")
    fun deleteCinema(@RequestParam(name = "id", required = true) id: String, response: HttpServletResponse): String? {
        return deleteInstance(id, "Cinema", cinemaService, response)
    }

}